package	jp.co.sds_corp.ratemixer.fx.command;

import java.util.Iterator;
import java.util.Map;

import jp.co.sds_corp.fxutil.CcyPair;
import jp.co.sds_corp.ratemixer.fx.FxRate;
import jp.co.sds_corp.test.BasicTestCase;
import jp.co.sds_corp.transfer.IReceiveListener;
import jp.co.sds_corp.transfer.ReceiveEvent;
import jp.co.sds_corp.transfer.StatusChangeEvent;
import jp.co.sds_corp.util.config.DOMConfiguration;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.daemon.manager.DaemonManager;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class TestCommand extends BasicTestCase
{
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);

	public void setUp() throws Exception {
	}

	public void testCommand1() {
	}

	public void start() throws Exception {
		String file = System.getProperty( "test.config" );
		DOMConfiguration config = new DOMConfiguration( file );

		IConfiguration cmdconf = config.getChild( "Command" );
		commandTest( cmdconf );
/*
		IConfiguration mixconf = config.getChild( "Daemon" );
		ServiceLoader svc = new ServiceLoader();
		svc.init( mixconf );
		svc.start();
*/
		DaemonManager manager = DaemonManager.getInstance();
		manager.init( config );

		jp.co.sds_corp.transfer.ServiceLoader loader = jp.co.sds_corp.transfer.ServiceLoader.getInstance();
		loader.addReceiveListener( new IReceiveListener() {
			private static final long serialVersionUID = 1L;
			public void received( ReceiveEvent ev ) {
				FxRate rate = (FxRate )ev.getData();
				logger.debug( "receive:" + rate );
			}
			public void statusChanged( StatusChangeEvent ev ) {
				logger.debug( "status changed:" + ev );
			}
		} );
		manager.start();
	}

	public void commandTest( IConfiguration config ) throws Exception {
		ICommander cmd = CommanderFactory.createCommander( config );
		CcyPairProperty prop = cmd.getCcyPairProperty( "USD", "JPY" );
		logger.debug( "spread=" + prop.getSpread()
			+ " skew=" + prop.getSkew() + " bias=" + prop.getBias() );
		prop.setSpread( 3 );
		prop.setSkew( 2 );
		prop.setBias( 1 );
		cmd.setCcyPairProperty( "USD", "JPY", prop );

		Map<String,CcyPair> map = cmd.mapCcyPair();
		Iterator<String> itr = map.keySet().iterator();
		while ( itr.hasNext()) {
			Object key = itr.next();
			CcyPair pair = (CcyPair )map.get( key );
			CcyPairProperty getcp = cmd.getCcyPairProperty(
				pair.getCcy1().getCode(), pair.getCcy2().getCode() );
			System.out.println( pair
				+ " spread=" + getcp.getSpread()
				+ " skew=" + getcp.getSkew() + " bias=" + getcp.getBias() );
			try {
				FxRate rate = cmd.getSpotRate(
					pair.getCcy1().getCode(), pair.getCcy2().getCode() );
				System.out.println( rate );
			} catch ( CommandException cex ) {
				cex.printStackTrace();
			}
		}
	}

	public static void main( String[] args ) {
		try {
			TestCommand obj = new TestCommand();
			obj.start();
		} catch ( Exception ex ) {
			ex.printStackTrace();
		}
	}
}
